<?php
App::uses('EvSlideShowAppController', 'EvSlideShow.Controller');
/**
 * SlideshowSlides Controller
 *
 */
class EvSlidesController extends EvSlideShowAppController {

	public $max_depth = 1;

	/**
	 * @see Controller::beforeFilter()
	 */
	public function beforeFilter() {

		parent::beforeFilter();

		$this->Auth->allow(array(
			'fetchSlideshow'
		));
	}


	public function fetchSlideshow() {
		return $this->Slide->getSlides();
	}

	protected function _adminIndexColumns() {

		$columns = array(
			'Slide.name' => array(
				'type' => 'string',
				'null' => false,
				'default' => null,
				'length' => (int) 200,
				'collate' => 'utf8_general_ci',
				'charset' => 'utf8',
				'label' => 'Name'
			),
			// 'Slide.orderno' => array(
			// 	'type' => 'integer',
			// 	'null' => true,
			// 	'default' => null,
			// 	'length' => (int) 11,
			// 	'label' => 'Orderno'
			// )
		);

		return $columns;
	}

	protected function _adminFormFields() {
		$fields = parent::_adminFormFields();

		$config_fields = Configure::read('SlideShow.fields');
		foreach ($config_fields as $key => $value) {

			if ($key == 'extra') {

				foreach ($value as $extra_key => $extra_value) {

					if (isset($extra_value['validate'])) {

						unset($config_fields[$key][$extra_key]['validate']);
					}
				}
			} else {

				if (isset($value['validate'])) {

					unset($config_fields[$key]['validate']);
				}
			}
		}

		$fields = array_merge($fields, $config_fields);

		unset($fields['orderno']);
		$fields['description']['type'] = 'hidden';

		return $fields;
	}

	/**
	 * Defines the fields displayed in a filter form
	 *
	 * Defaults to all fields in the db table
	 *
	 * Override in your controller to customise
	 *
	 * Format:
	 *
	 * "id"=>array(
	 * 		"label"=>"label text",
	 * 		"type"=>"type of control to render: text, select etc.",
	 * 		"compare"=>"SQL query. e.g. Model.field='%s' (where %s is replace by the value of the field)"
	 * )
	 */
	protected function _adminFilterFields() {
		return array();
	}

	/**
	 * Defines which actions are available to each row of the admin_index table results
	 *
	 * Customise the handlers for these actions in /view/Admin/Elements/index_results.ctp
	 */
	protected function _adminIndexActions() {
		return array(
			'Edit',
			'Delete',
		);
	}

	/**
	 * Defines the tabs available in the admin form
	 *
	 * Defaults to just the Page Content form
	 */
	protected function _adminFormTabs() {
		return array(

		);
	}

	protected function _processValidation()
	{
		// add the custom validation if set
		$config_fields = Configure::read('SlideShow.fields');
		foreach ($config_fields as $key => $value) {

			if ($key == 'extra') {

				foreach ($value as $extra_key => $extra_value) {

					if (! empty($extra_value['validate'])) {

						$this->Slide->validate['extra_' . $extra_key] = array();

						foreach ($extra_value['validate'] as $rule => $rule_data) {

							$this->Slide->validate['extra_' . $extra_key][$rule] = $rule_data;
						}
					}
				}
			} else {

				if (! empty($value['validate'])) {

					foreach ($value['validate'] as $rule => $rule_data) {

						$this->Slide->validate[$key][$rule] = $rule_data;
					}

				}
			}
		}
	}

	public function admin_edit($id = null)
	{
		$this->_processValidation();

		parent::admin_edit($id);
		$this->view = 'SlideShow.admin_form';
	}

}
