<?php
App::uses('EvSlideShowAppModel', 'EvSlideShow.Model');
/**
 * SlideshowSlide Model
 *
 */
class Slide extends EvSlideShowAppModel {

	public $imageSlots = array(
		'main' => array(
			'slots' => 1,
			'fields' => false
		)
	);

	public $hasMany = array(
		'Image' => array(
			'className' => 'Images.Image',
			'foreignKey' => 'foreign_key',
			'conditions' => array(
				'model' => 'Slide',
				'attachment_type' => 'Image',
			),
			'dependent' => true,
			'cascade' => true
		)
	);

/**
 * Validation rules
 *
 * @var array
 */
	public $validate = array(
		'name' => array(
			'notempty' => array(
				'rule' => array('notempty'),
				'message' => 'Slides must have a name',
				//'allowEmpty' => false,
				//'required' => false,
				//'last' => false, // Stop validation after this rule
				//'on' => 'create', // Limit validation to 'create' or 'update' operations
			),
		),
	);

	public function getSlides() {
		$slides = $this->find('all', array(
				'order' => 'orderno',
				'contain' => array(
					'Image'
				),
				'joins' => array(
					array(
						'table' => 'images',
						'alias' => 'Image',
						// 'type' => 'RIGHT',
						'conditions' => array(
							"Image.model = 'Slide'",
							"Image.attachment_type = 'Image'",
							"Image.model_id = Slide.id",
						)
					)

				)
			)
		);

		return $slides;
	}

	public function beforeSave($options = array())
	{
		$extra = array();

		foreach ($this->data['Slide'] as $field => $value) {

			if (substr($field, 0, 6) == 'extra_') {

				$extra[substr($field, 6)] = $value;
				unset($this->data['Slide'][$field]);
			}
		}
		$this->data['Slide']['extra'] = serialize($extra);

		return true;
	}

	public function afterFind($results, $primary = false)
	{
		foreach ($results as $k => $slide) {

			if (isset($slide['Slide']['extra'])) {

				$extra = unserialize($slide['Slide']['extra']);

				if (is_array($extra)) {

					foreach ($extra as $key => $value) {

						$results[$k]['Slide']['extra_' . $key] = $value;
					}
				}
				unset($results[$k]['Slide']['extra']);
			}
		}

		return $results;
	}

}
